
;WrCon - dedndave

        INCLUDE \masm32\include\masm32rt.inc

;------------------------------------------------------------------------------------------------------------------------------

BufHght EQU 25                                          ;buffer height (rows)
BufWdth EQU 80                                          ;buffer width (columns)
BufLen  EQU BufHght*BufWdth                             ;string length (tchars)

;------------------------------------------------------------------------------------------------------------------------------

        .DATA

ByteCount dd 4*BufLen                                   ;Bytes to read from input file
ConTitle  db "Win32 Console 80 x 25 Fixed Size - Extended ASCII chart", 0

;------------------------------------------------------------------------------------------------------------------------------

        .DATA?

hStdOut dd ?
hStdInp dd ?
hFile   dd ?

CharBuf CHAR_INFO BufLen dup(<>)

;CHAR_INFO STRUCT
;  Char          CHARTYPE <>
;  Attributes    WORD      ?
;CHAR_INFO ENDS

;CHARTYPE UNION
; UnicodeChar    WORD ?
; AsciiChar      db ?
;CHARTYPE ENDS

SizCord COORD <>
LocCord COORD <>

;COORD STRUCT
;  x  WORD      ?
;  y  WORD      ?
;COORD ENDS

WrRgn  SMALL_RECT <>

;SMALL_RECT STRUCT
;  Left      WORD      ?
;  Top       WORD      ?
;  Right     WORD      ?
;  Bottom    WORD      ?
;SMALL_RECT ENDS

InpByte db ?

;------------------------------------------------------------------------------------------------------------------------------

        .CODE

_main   PROC

;initialize program

        call    PInit

;read screen data file to fill CharBuf

        mov     hFile,fopen("myfiles.txt")
        mov     ebx,fread(hFile,offset CharBuf,ByteCount)
        fclose  hFile

; mov ecx,2000
; mov edi,offset CharBuf
;test00:
; mov dword ptr [edi],0A0041h
; add edi,4
; dec ecx
; jnz test00

;set structure values

        mov word ptr SizCord.x,BufWdth
        mov word ptr SizCord.y,BufHght

        mov word ptr LocCord.x,0
        mov word ptr LocCord.y,0

        mov word ptr WrRgn.Left,0
        mov word ptr WrRgn.Top,0
        mov word ptr WrRgn.Right,BufWdth-1
        mov word ptr WrRgn.Bottom,BufHght-1

;set the screen buffer size

        INVOKE  SetConsoleScreenBufferSize,hStdOut,dword ptr SizCord

;set the window size and position

        INVOKE  SetConsoleWindowInfo,hStdOut,TRUE,offset WrRgn

;write to console

        INVOKE  WriteConsoleOutput,hStdOut,offset CharBuf,dword ptr SizCord,dword ptr LocCord,offset WrRgn

;wait for a keypress, then terminate

        INVOKE  ReadConsole,hStdInp,offset InpByte,1,NULL,NULL
        INVOKE  ExitProcess,0

_main   ENDP

;------------------------------------------------------------------------------------------------------------------------------

PInit   PROC

        INVOKE  SetConsoleTitle,offset ConTitle
        INVOKE  GetStdHandle,STD_INPUT_HANDLE
        mov     hStdInp,eax
        INVOKE  GetStdHandle,STD_OUTPUT_HANDLE
        mov     hStdOut,eax
        ret

PInit   ENDP

;------------------------------------------------------------------------------------------------------------------------------

        END     _main

